aboutsummaryrefslogtreecommitdiff
path: root/collection/anaconda/install.sh
diff options
context:
space:
mode:
authorJosh Spicer <josh@joshspicer.com>2022-05-10 01:16:15 +0300
committerGitHub <noreply@github.com>2022-05-10 01:16:15 +0300
commit9efe4b3c4a5f07c45cf6ed69900006eed0e844b9 (patch)
tree1c120109a1794b913a3c71df0a456eb0ad411a54 /collection/anaconda/install.sh
parent8759124c532d93b6e1ab38e391554d287b956d83 (diff)
init (#1)
* init * some copy pastin * install.sh ref * fixes
Diffstat (limited to 'collection/anaconda/install.sh')
-rw-r--r--collection/anaconda/install.sh99
1 files changed, 99 insertions, 0 deletions
diff --git a/collection/anaconda/install.sh b/collection/anaconda/install.sh
new file mode 100644
index 0000000..c77d98d
--- /dev/null
+++ b/collection/anaconda/install.sh
@@ -0,0 +1,99 @@
+#!/usr/bin/env bash
+#-------------------------------------------------------------------------------------------------------------
+# Copyright (c) Microsoft Corporation. All rights reserved.
+# Licensed under the MIT License. See https://go.microsoft.com/fwlink/?linkid=2090316 for license information.
+#-------------------------------------------------------------------------------------------------------------
+#
+# Docs: https://github.com/microsoft/vscode-dev-containers/blob/main/script-library/docs/anaconda.md
+# Maintainer: The VS Code and Codespaces Teams
+#
+# Syntax: ./anaconda-debian.sh [Conda version] [CONDA_DIR] [Non-root user] [Add rc files flag]
+
+VERSION=${1:-"latest"}
+export CONDA_DIR=${2:-"/usr/local/conda"}
+USERNAME=${3:-"automatic"}
+UPDATE_RC=${4:-"true"}
+
+set -eux
+export DEBIAN_FRONTEND=noninteractive
+
+if [ "$(id -u)" -ne 0 ]; then
+ echo -e 'Script must be run as root. Use sudo, su, or add "USER root" to your Dockerfile before running this script.'
+ exit 1
+fi
+
+# Ensure that login shells get the correct path if the user updated the PATH using ENV.
+rm -f /etc/profile.d/00-restore-env.sh
+echo "export PATH=${PATH//$(sh -lc 'echo $PATH')/\$PATH}" > /etc/profile.d/00-restore-env.sh
+chmod +x /etc/profile.d/00-restore-env.sh
+
+# Determine the appropriate non-root user
+if [ "${USERNAME}" = "auto" ] || [ "${USERNAME}" = "automatic" ]; then
+ USERNAME=""
+ POSSIBLE_USERS=("vscode" "node" "codespace" "$(awk -v val=1000 -F ":" '$3==val{print $1}' /etc/passwd)")
+ for CURRENT_USER in ${POSSIBLE_USERS[@]}; do
+ if id -u ${CURRENT_USER} > /dev/null 2>&1; then
+ USERNAME=${CURRENT_USER}
+ break
+ fi
+ done
+ if [ "${USERNAME}" = "" ]; then
+ USERNAME=root
+ fi
+elif [ "${USERNAME}" = "none" ] || ! id -u ${USERNAME} > /dev/null 2>&1; then
+ USERNAME=root
+fi
+
+architecture="$(uname -m)"
+if [ "${architecture}" != "x86_64" ]; then
+ echo "(!) Architecture $architecture unsupported"
+ exit 1
+fi
+
+updaterc() {
+ if [ "${UPDATE_RC}" = "true" ]; then
+ echo "Updating /etc/bash.bashrc and /etc/zsh/zshrc..."
+ if [[ "$(cat /etc/bash.bashrc)" != *"$1"* ]]; then
+ echo -e "$1" >> /etc/bash.bashrc
+ fi
+ if [ -f "/etc/zsh/zshrc" ] && [[ "$(cat /etc/zsh/zshrc)" != *"$1"* ]]; then
+ echo -e "$1" >> /etc/zsh/zshrc
+ fi
+ fi
+}
+
+# Checks if packages are installed and installs them if not
+check_packages() {
+ if ! dpkg -s "$@" > /dev/null 2>&1; then
+ apt-get update
+ apt-get -y install --no-install-recommends "$@"
+ fi
+}
+
+# Install Conda if it's missing
+if ! conda --version &> /dev/null ; then
+ # Install dependencies
+ check_packages wget ca-certificates
+
+ mkdir -p $CONDA_DIR
+ chown ${USERNAME}:root $CONDA_DIR
+ echo "Installing Anaconda..."
+
+ CONDA_VERSION=$VERSION
+ if [ "${VERSION}" = "latest" ] || [ "${VERSION}" = "lts" ]; then
+ CONDA_VERSION="2021.11"
+ fi
+
+ su --login -c "wget -q https://repo.anaconda.com/archive/Anaconda3-${CONDA_VERSION}-Linux-x86_64.sh -O /tmp/anaconda-install.sh \
+ && /bin/bash /tmp/anaconda-install.sh -u -b -p ${CONDA_DIR}" ${USERNAME} 2>&1
+
+ if [ "${VERSION}" = "latest" ] || [ "${VERSION}" = "lts" ]; then
+ PATH=$PATH:${CONDA_DIR}/bin
+ conda update -y conda
+ fi
+
+ rm /tmp/anaconda-install.sh
+ updaterc "export CONDA_DIR=${CONDA_DIR}/bin"
+fi
+
+echo "Done!" \ No newline at end of file